=== src/utils/CMakeLists.txt ===
#add_library(esdm SHARED esdm-datatypes.c  esdm-layout.c  esdm-performancemodel.c  esdm-scheduler.c  esdm-siteconfiguration.c)
#target_link_libraries(esdm ${GLIB_LIBRARIES})
#link_directories(esdm ${GLIB_LIBRARIES})
#include_directories(${CMAKE_SOURCE_DIR}/include/ ${CMAKE_BINARY_DIR} ${GLIB_INCLUDE_DIRS})

## Installation
#install(TARGETS h5-memvol LIBRARY DESTINATION lib)
