=== debian/changelog ===
esdm (1.0-2) experimental; urgency=medium

  * Add cmake as build-dep. Closes: #1008148

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 23 Mar 2022 10:30:43 +0000

esdm (1.0-1) experimental; urgency=medium

  * Initial release. (Closes: #969088)
    - Add minimal support for /etc/esdm/esdm.conf; examples
  * Resubmit to NEW; src/deps has MIT license

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 23 Feb 2022 12:46:13 +0100
