=== debian/control ===
Source: esdm
Section: utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
 dh-buildinfo, 
 chrpath,
 cmake,
 libglib2.0-dev,
 libhdf5-mpi-dev (>= 1.12.0+repack-1~exp2),
 pkg-config,
 mpi-default-dev,
 libjansson-dev,
 libs3-dev,
 libpmem-dev,
 libtool,
 libtool-bin,
 doxygen,
 plantuml
Standards-Version: 4.6.0
Homepage: https://github.com/ESiWACE/esdm
Vcs-Browser: https://salsa.debian.org:/science-team/esdm.git
Vcs-Git: https://salsa.debian.org:/science-team/esdm.git -b debian/latest

Package: esdm-tools
Architecture: any
Depends: libesdm0d (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Earth System Data  Middleware
 Climate Data Operators are a collection of command line Operators 
 to manipulate and analyse Climate model Data.  Supported data formats are GRIB, 
 netCDF, SERVICE, EXTRA and IEG. There are more than 400 operators available.

Package: libesdm0d
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Earth System Data  Middleware - libraries
 Climate Data Operators are a collection of command line Operators 
 to manipulate and analyse Climate model Data.  Supported data formats are GRIB, 
 netCDF, SERVICE, EXTRA and IEG. There are more than 400 operators available.

Package: libesdm-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, libesdm0d (= ${binary:Version})
Description: Earth System Data  Middleware - devel files
 Climate Data Operators are a collection of command line Operators 
 to manipulate and analyse Climate model Data.  Supported data formats are GRIB, 
 netCDF, SERVICE, EXTRA and IEG. There are more than 400 operators available.
